﻿using Contracts.Generated.Flows.Schuldbemiddeling.v1;
using Infrastructure.Utils.Xml;
using MessageboxBericht = SoapEndpoint.Service.Systeem.v1.MessageBoxService.MessageboxBericht;
using MessageboxBerichtinformatie = SoapEndpoint.Service.Systeem.v1.MessageBoxService.MessageboxBerichtinformatie;

namespace SoapEndpoint.Tester.Infrastructure;

public class MessageBoxMessageHandler
{
    private readonly Dictionary<Berichttype, Action<MessageboxBericht>> _handlers = new();

    public void AddHandler<T>(Berichttype type, Action<T, MessageboxBericht> action)
    {
        _handlers.Add(type, GetHandler(action));
    }

    private static Action<MessageboxBericht> GetHandler<T>(Action<T, MessageboxBericht> handler)
    {
        void Action(MessageboxBericht message)
        {
            var obj = DataContractSerializeHelper.Deserialize<T>(message.Content);
            handler(obj, message);
        }

        return Action;
    }

    public void OnMessageReceived(MessageboxBerichtinformatie info)
    {
        foreach (var message in info.Berichten)
        {
            var messageType = (Berichttype)Enum.Parse(typeof(Berichttype), message.Berichttype);
            _handlers[messageType](message);
        }
    }
}