﻿using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v1.ErrorMessage;
using SoapEndpoint.Service.Systeem.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.Schuldbemiddeling;

namespace SoapEndpoint.Tester.Scenario.Implementations.Schuldbemiddeling;

public class FouteConversatieRefScenario : SchuldbemiddelingScenarioBase
{
    public override string Name => "Foute conversation referentie";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("SE Foute conversation referentie");
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(Berichttype.SHV_Saldoverzoek, Berichttype.SE_SaldoverzoekAntwoord));

        // Send a statusverzoek in an unknown conversation
        var seConv = new Conversation(FlowType);
        await Manager.SE_SendMessageAsync(seConv, Berichttype.SE_Statusverzoek);
        await Manager.SE_GetAndConfirmErrorMessage<ShvKnooppuntFoutbericht, Berichttype, ShvKnooppuntFoutcode>(seConv,
            Berichttype.SYS_FoutBericht, ShvKnooppuntFoutcode.Onbekendeconversatie);

        StartNewScenario("SHV Foute conversation referentie");
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(Berichttype.SHV_Saldoverzoek, Berichttype.SE_SaldoverzoekAntwoord));

        // Send a betaalvoorstel in an unknown conversation
        var shvConv = new Conversation(FlowType);
        await Manager.SHV_SendMessageAsync(shvConv, Berichttype.SHV_Betaalvoorstel);
        await Manager.SHV_GetAndConfirmErrorMessage<ShvKnooppuntFoutbericht, Berichttype, ShvKnooppuntFoutcode>(shvConv,
            Berichttype.SYS_FoutBericht, ShvKnooppuntFoutcode.Berichttypemaggeennieuweconversatiestarten,
            ShvKnooppuntFoutcode.Berichttypeniettoegestaanvoordehuidigestaatvandeconversatie);
    }
}