namespace SoapEndpoint.Service.Proxy.Models.Flows;

public class RequestReply<TMessageType> where TMessageType : Enum
{
    public RequestReply(Message<TMessageType> requestMessage, Message<TMessageType>? replyMessage = default)
    {
        RequestMessage = requestMessage;
        ReplyMessage = replyMessage;
    }

    public Message<TMessageType> RequestMessage { get; }
    public Message<TMessageType>? ReplyMessage { get; set; }

    public override string ToString()
    {
        var requestMessage =
            $"RequestType: {RequestMessage.MessageType}, RequestResultType: {RequestMessage.ResultMessageType}";
        return ReplyMessage is null
            ? requestMessage
            : $"{requestMessage}, ReplyType: {ReplyMessage.MessageType}, ReplyResultType: {ReplyMessage.ResultMessageType}";
    }
}