﻿using AutoMapper;
using SoapEndpoint.Service.Flows.Waarborgfonds.v1.SeService;
using SoapEndpoint.Service.Proxy.Models.Flows;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using BerichtType = SoapEndpoint.Service.Flows.Waarborgfonds.v1.LogbookService.BerichtType;

namespace SoapEndpoint.Service.Proxy.ServiceProxies.Flows.Waarborgfonds.v1;

public class SeProxy : IMessageProxy<BerichtType>
{
    private readonly IMapper _mapper;
    private readonly ISoapSeService _service;

    public SeProxy(IMapper mapper, ISoapSeService service)
    {
        _mapper = mapper;
        _service = service;
    }

    public async Task<ShvKnooppuntBerichtBevestigingModel> SendMessageAsync(BerichtHeaderModel header,
        BerichtModel<BerichtType> bericht)
    {
        var request = new SendMessageRequest
        {
            bericht = _mapper.Map<SeBericht>(bericht),
            Header = _mapper.Map<BerichtHeaderWaarborgfonds>(header)
        };

        var response = await _service.SendMessageAsync(request);
        return _mapper.Map<ShvKnooppuntBerichtBevestigingModel>(response.SendMessageResult);
    }
}